<!--
 * @Descripttion: (轮播图/tb_banner 添加弹窗)
 * @version: (1.0)
 * @Author: (lwh)
 * @Date: (2023-10-09)
 * @LastEditors: (lwh)
 * @LastEditTime: (2023-10-09)
-->
<template>
  <el-dialog v-model="props.modelValue" title="添加轮播图信息" width="900px" @closed="closeDialog" @open="openDialog">
    <el-form ref="formRef" :model="formData" :rules="rules">
      <el-row :gutter="20">


        <el-col :lg="12">
          <el-form-item :label-width="labelWidth" label="位置" prop="bannerPosition">
            <el-select v-model="formData.bannerPosition" placeholder="请选择位置">
              <el-option v-for="item in  banner_position " :key="item.dictValue" :label="item.dictLabel"
                :value="parseInt(item.dictValue)"></el-option>
            </el-select>
          </el-form-item>
        </el-col>
        <el-col :lg="12">
          <el-form-item :label-width="labelWidth" label="图片" prop="bannerImg">
            <UploadImage ref="uploadRef" v-model="formData.bannerImg" :data=imgData :limit="1" :fileSize="5"
              :drag="true" />
          </el-form-item>
        </el-col>
        <el-col :lg="12">
          <el-form-item :label-width="labelWidth" label="排序" prop="bannerSort">
            <el-input-number v-model.number="formData.bannerSort" controls-position="right" :min="0" />
          </el-form-item>
        </el-col>

      </el-row>
    </el-form>

    <template #footer>
      <div key="dialog-footer">
        <el-button type="primary" @click="handleAddClick(formRef)" :loading="loadingStatus">添加</el-button>
        <el-button @click="handleResetClick(formRef)">重置</el-button>
      </div>
    </template>
  </el-dialog>
</template>


<script setup>
import { reactive, ref, watch } from "vue";
import { ElMessage } from 'element-plus'
import modal from '@/plugins/modal.js'
import { addOrUpdateBanner } from '@/api/business/Advertisement/Banners/banner.js';


// 打开弹窗时回调
const openDialog = async () => {

  await getbanner_position()

}

// -业务参数
// 位置字典选项列表
const banner_position = ref([]);


// -业务方法
// 字典获取
async function getbanner_position() {
  await proxy.getDicts('banner_position').then((res) => {
    banner_position.value = res.data
  })
}



// -基础参数
const loadingStatus = ref(false)
const labelWidth = 100;
const formRef = ref();
const { proxy } = getCurrentInstance()
const emits = defineEmits(["update:modelValue"]);
const formData = reactive({
  bannerPosition: 1,
  bannerSort: 100
});
const props = defineProps({
  modelValue: Boolean,
  done: Function,
});
const imgData = ref({
  fileDir: "Banner"
})

// 验证
const rules = reactive({
  bannerGuid: [{ required: true, message: "不能为空", trigger: "blur", type: "number" }],
  bannerPosition: [{ required: true, message: "位置不能为空", trigger: "change", type: "number" }],
  bannerImg: [{ required: true, message: "图片不能为空", trigger: "blur" }],
  bannerSort: [{ required: true, message: "排序不能为空", trigger: "blur", type: "number" }],
});

// -基础方法

// 提交
const handleAddClick = async (formEl) => {
  if (!formEl) return;
  formEl.validate(async (valid) => {
    if (!valid) {
      return;
    }
    loadingStatus.value = true


    const { code } = await addOrUpdateBanner(formData);
    if (code == 200) {
      modal.msgSuccess('添加成功')
      closeDialog();
      loadingStatus.value = false
    }
  });
};
const closeDialog = () => {
  handleResetClick(formRef.value);
  props.done();
  emits("update:modelValue", false);
};
const handleResetClick = async (formEl) => {
  if (!formEl) return;
  formEl.resetFields();
};
</script>